# Encoding: UTF-8
#
# Cookbook Name:: snoopy
# Library:: matchers
#
# Copyright 2015 Socrata, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

if defined?(ChefSpec)
  [:snoopy, :snoopy_app, :snoopy_config, :snoopy_service].each do |m|
    ChefSpec.define_matcher(m)
  end

  {
    snoopy: [:create, :remove],
    snoopy_app: [:install, :remove],
    snoopy_config: [:create, :remove],
    snoopy_service: [:enable, :disable]
  }.each do |resource, actions|
    actions.each do |action|
      define_method("#{action}_#{resource}") do |name|
        ChefSpec::Matchers::ResourceMatcher.new(resource, action, name)
      end
    end
  end
end
